'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.assertCommand = exports.InvalidCommandError = exports.COMMAND = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const COMMAND = exports.COMMAND = {
  ADDR: 'addr',
  BLOCK: 'block',
  CONSENSUS: 'consensus',
  FILTER_ADD: 'filteradd',
  FILTER_CLEAR: 'filterclear',
  FILTER_LOAD: 'filterload',
  GET_ADDR: 'getaddr',
  GET_BLOCKS: 'getblocks',
  GET_DATA: 'getdata',
  GET_HEADERS: 'getheaders',
  HEADERS: 'headers',
  INV: 'inv',
  MEMPOOL: 'mempool',
  TX: 'tx',
  VERACK: 'verack',
  VERSION: 'version',
  ALERT: 'alert',
  MERKLE_BLOCK: 'merkleblock',
  NOT_FOUND: 'notfound',
  PING: 'ping',
  PONG: 'pong',
  REJECT: 'reject'
};

let InvalidCommandError = exports.InvalidCommandError = function (_Error) {
  (0, _inherits3.default)(InvalidCommandError, _Error);

  function InvalidCommandError(command) {
    (0, _classCallCheck3.default)(this, InvalidCommandError);

    var _this = (0, _possibleConstructorReturn3.default)(this, (InvalidCommandError.__proto__ || (0, _getPrototypeOf2.default)(InvalidCommandError)).call(this, `Expected command, found: ${command}`));

    _this.command = command;
    return _this;
  }

  return InvalidCommandError;
}(Error);

const assertCommand = exports.assertCommand = command => {
  switch (command) {
    case 'addr':
      return COMMAND.ADDR;
    case 'block':
      return COMMAND.BLOCK;
    case 'consensus':
      return COMMAND.CONSENSUS;
    case 'filteradd':
      return COMMAND.FILTER_ADD;
    case 'filterclear':
      return COMMAND.FILTER_CLEAR;
    case 'filterload':
      return COMMAND.FILTER_LOAD;
    case 'getaddr':
      return COMMAND.GET_ADDR;
    case 'getblocks':
      return COMMAND.GET_BLOCKS;
    case 'getdata':
      return COMMAND.GET_DATA;
    case 'getheaders':
      return COMMAND.GET_HEADERS;
    case 'headers':
      return COMMAND.HEADERS;
    case 'inv':
      return COMMAND.INV;
    case 'mempool':
      return COMMAND.MEMPOOL;
    case 'tx':
      return COMMAND.TX;
    case 'verack':
      return COMMAND.VERACK;
    case 'version':
      return COMMAND.VERSION;
    case 'alert':
      return COMMAND.ALERT;
    case 'merkleblock':
      return COMMAND.MERKLE_BLOCK;
    case 'notfound':
      return COMMAND.NOT_FOUND;
    case 'ping':
      return COMMAND.PING;
    case 'pong':
      return COMMAND.PONG;
    case 'reject':
      return COMMAND.REJECT;
    default:
      throw new InvalidCommandError(command);
  }
};