"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.assertInventoryType = exports.InvalidInventoryTypeError = exports.INVENTORY_TYPE = undefined;

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const INVENTORY_TYPE = exports.INVENTORY_TYPE = {
  TRANSACTION: 0x01,
  BLOCK: 0x02,
  CONSENSUS: 0xe0
};

let InvalidInventoryTypeError = exports.InvalidInventoryTypeError = function (_Error) {
  (0, _inherits3.default)(InvalidInventoryTypeError, _Error);

  function InvalidInventoryTypeError(inventoryType) {
    (0, _classCallCheck3.default)(this, InvalidInventoryTypeError);

    var _this = (0, _possibleConstructorReturn3.default)(this, (InvalidInventoryTypeError.__proto__ || (0, _getPrototypeOf2.default)(InvalidInventoryTypeError)).call(this, `Expected inventory type, found: ${inventoryType}`));

    _this.inventoryType = inventoryType;
    return _this;
  }

  return InvalidInventoryTypeError;
}(Error);

const assertInventoryType = exports.assertInventoryType = inventoryType => {
  switch (inventoryType) {
    case INVENTORY_TYPE.TRANSACTION:
      return INVENTORY_TYPE.TRANSACTION;
    case INVENTORY_TYPE.BLOCK:
      return INVENTORY_TYPE.BLOCK;
    case INVENTORY_TYPE.CONSENSUS:
      return INVENTORY_TYPE.CONSENSUS;
    default:
      throw new InvalidInventoryTypeError(inventoryType);
  }
};