'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.SERVICES = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _bn = require('bn.js');

var _bn2 = _interopRequireDefault(_bn);

var _neoBlockchainCore = require('neo-blockchain-core');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const SERVICES = exports.SERVICES = {
  NODE_NETWORK: new _bn2.default(1)
};

let VersionPayload = function () {
  function VersionPayload({
    protocolVersion,
    services,
    timestamp,
    port,
    nonce,
    userAgent,
    startHeight,
    relay
  }) {
    (0, _classCallCheck3.default)(this, VersionPayload);
    this.serializeWire = (0, _neoBlockchainCore.createSerializeWire)(this.serializeWireBase.bind(this));

    this.protocolVersion = protocolVersion;
    this.services = services;
    this.timestamp = timestamp;
    this.port = port;
    this.nonce = nonce;
    this.userAgent = userAgent;
    this.startHeight = startHeight;
    this.relay = relay;
  }

  (0, _createClass3.default)(VersionPayload, [{
    key: 'serializeWireBase',
    value: function serializeWireBase(writer) {
      writer.writeUInt32LE(this.protocolVersion);
      writer.writeUInt64LE(this.services);
      writer.writeUInt32LE(this.timestamp);
      writer.writeUInt16LE(this.port);
      writer.writeUInt32LE(this.nonce);
      writer.writeVarString(this.userAgent);
      writer.writeUInt32LE(this.startHeight);
      writer.writeBoolean(this.relay);
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase({ reader }) {
      const protocolVersion = reader.readUInt32LE();
      const services = reader.readUInt64LE();
      const timestamp = reader.readUInt32LE();
      const port = reader.readUInt16LE();
      const nonce = reader.readUInt32LE();
      const userAgent = reader.readVarString(1024);
      const startHeight = reader.readUInt32LE();
      const relay = reader.readBoolean();
      return new this({
        protocolVersion,
        services,
        timestamp,
        port,
        nonce,
        userAgent,
        startHeight,
        relay
      });
    }
  }, {
    key: 'deserializeWire',
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _neoBlockchainCore.BinaryReader(options.buffer)
      });
    }
  }]);
  return VersionPayload;
}();

exports.default = VersionPayload;